/* Density dependent birth and death epidemic process */
/* Applied Mathematical Sciences C2: Year 2000 */
/* By Tetsuo Fujimagari <fjmagari@kenroku.kanazawa-u.ac.jp> */
/* April 24 Mon.,2000: 16:30 modified on May 27,2002 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double frand(void)
{
	return 1.0-(double)rand()/(RAND_MAX+1.0);
}

   /*------------- START THE MAIN PROGRAM ----------------*/

 void main(void)
{
	long int	seed,
				K, /* carrying capacity */
				size; /* size at each time of the process */
	double	brate, /* birth rate */
			drate, /* death rate */
			t; /* present time */
	char	*file1 = "datax.dat",*file2 = "samplex.dat";
	FILE	*fp1,*fp2;

   /*----------------- initial parameters -----------------*/

	printf(" Carrying capacity (large positive integer) = ");
	scanf("%d",&K);
	printf("\n");
	printf(" Birth rate (any positive real number) = ");
	scanf("%lf",&brate);
	printf("\n");
	printf(" Death rate (any positive real number) = ");
	scanf("%lf",&drate);
	printf("\n");
	printf(" Initial size of the process (not so large positive integer) = ");
	scanf("%d",&size);
	printf("\n");
	printf(" Random number seed (any integer) = ");
	scanf("%d",&seed);
	printf("\n\n");

  /* -------------------------------------------------------*/

	fp1=fopen(file1,"w");
	fprintf(fp1,"      << Density dependent birth and death epidemic process >>\n\n");
	fprintf(fp1," Carrying capacity = %d\n\n",K);
	fprintf(fp1," Birth rate =%3.3f\n\n",brate);
	fprintf(fp1," Death rate =%3.3f\n\n",drate);
	fprintf(fp1," Initial size of the process = %d\n\n",size);
	fprintf(fp1," Random number seed = %d\n\n",seed);
/*	fclose(fp1);*/

  /*--------------- start here ------------------*/

	fp2=fopen(file2,"w");
	fprintf(fp2,"%5.3f\t %10d\n",0.0,size);
	srand(seed); /* giving the seed of rand */
	t=0.0;
	while (size>0) {
		t+=-log(frand())/((double)size*(brate*(1.0-(double)size/(double)K)+drate));
		fprintf(fp2,"%10.8lf\t %10d\n",t,size);
		if (frand()<drate/(brate*(1.0-(double)size/(double)K)+drate)) {
		--size;--K;}
		else ++size;
		fprintf(fp2,"%10.8lf\t %10d\n",t,size);
	}

	fclose(fp2);

	fprintf(fp1," Final uninfected size = %d\n\n",K);
	fclose(fp1);
}
