/* Pure birth process with carrying capacity */
/* Applied Mathematical Sciences C2: Year 2000 */
/* By Tetsuo Fujimagari <fjmagari@kenroku.kanazawa-u.ac.jp> */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double frand(void)
{
	return 1.0-(double)rand()/(RAND_MAX+1.0);
}

   /*------------- START THE MAIN PROGRAM ----------------*/

void main(void)
{
	long int	seed,
				K, /* carrying capacity */
				size; /* size at each time of the process */

	double	brate, /* birth rate */
			simtime, /* time to be simulated */
			t; /* present time */
	
	char	*file1 = "datax.dat",*file2 = "samplex.dat";
	FILE	*fp1,*fp2;

   /*----------------- initial parameters -----------------*/

	printf(" Carrying capacity (large positive integer) = ");
	scanf("%d",&K);
	printf("\n");

	printf(" Birth rate (any positive number) = ");
	scanf("%lf",&brate);
	printf("\n");

	printf(" Time to be simulated (positive number<=100) = ");
	scanf("%lf",&simtime);
	printf("\n");

	printf(" Initial size of the process (small positive integer) = ");
	scanf("%d",&size);
	printf("\n");

	printf(" Random number seed (any integer) = ");
	scanf("%d",&seed);
	printf("\n\n");

  /* -------------------------------------------------------*/

	fp1=fopen(file1,"w");

	fprintf(fp1,"      << Pure birth process with carrying capacity >>\n\n");

	fprintf(fp1," Carrying capacity = %d\n\n",K);

	fprintf(fp1," Birth rate =%3.3f\n\n",brate);

	fprintf(fp1," Time to be simulated =%4.2f\n\n",simtime);

	fprintf(fp1," Initial size of the process = %d\n\n",size);

	fprintf(fp1," Random number seed = %d\n",seed);

	fclose(fp1);

  /*--------------- start here ------------------*/

	fp2=fopen(file2,"w");

	fprintf(fp2,"%5.3f\t %10d\n",0.0,size);

	srand(seed); /* giving the seed of rand */

	t=0.0;
	while (t<simtime && size<K) {
		t+=-log(frand())/(brate*size*(1.0-(double)size/(double)K));
		fprintf(fp2,"%5.3f\t %10d\n",t,size);
		fprintf(fp2,"%5.3f\t %10d\n",t,++size);
	}

	fclose(fp2);
}
